package name.abhijitsarkar.javaee.cdiproducer;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;

@ApplicationScoped
public class Producer {
	Client client;

	@PostConstruct
	public void initClient() {
		client = ClientBuilder.newClient();

	}

	@PreDestroy
	public void dispoaseClient() {
		client.close();
	}

	@ApplicationScoped
	@Produces
	@name.abhijitsarkar.javaee.cdiproducer.Client
	public Client newClient() {
		return client;
	}
}
